PRINT "INIT ",pc

;###############################
!cluster = #$0B ;here put the cluster slot
;###############################

LDA #$01
STA $1510,x ;grafico
JSR seleccionar

LDA #$00
STA $C2,x ;accion. 0 = posarse, 1 = perseguir, 2 = subir.

LDA #$20
STA $1528,x ;timer para posarse

LDA #$0A
STA $1540,x ;timer para tirar humo


PRINT "MAIN ",pc

PHB		;\
PHK		; | Change the data bank to the one our code is running from.
PLB		; | This is a good practice.
JSR SpriteCode	; | Jump to the sprite's function.
PLB		; | Restore old data bank.
RTL		;/ And return.

;===================================
;Sprite Function
;===================================

RETURN: RTS

SpriteCode:
	JSR Graphics

	LDA $14C8,x			;\
	CMP #$08			; | If sprite dead,
	BNE RETURN			;/ Return.
	LDA $9D				;\
	BNE RETURN			;/ If locked, return.
	JSR SUB_OFF_SCREEN_X0
	
	JSR direccionGrafica	
	JSR colisionMario
	JSR detectarBala
	JSR timerPosado
	JSR desicionMov
	JSR direccionMov
    RTS

;====================================================
;================direccion Grafica===================
;====================================================

;Dirige que frame utilizar en este momento
retDG:
	RTS
direccionGrafica:
	LDA $163E,x
	BNE retDG
	
	LDA $1510,x
	CMP #$11
	BCC noMuriendoDG
	
	INC $1510,x
	
	LDA $1510,x
	CMP #$1A
	BCS morir
	JSR seleccionar
	RTS
morir:
	STZ $14C8,x	
	RTS
	
noMuriendoDG:

	LDA $C2,x
	BNE vuelaDG
	JSR PosarseDG
	JSR seleccionar
	RTS
	
vuelaDG:
	JSR volarDG
	JSR seleccionar
	RTS

Posarseble: db $01,$02,$03,$04,$05,$06,$07,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
;dirige que frame utilizar cuando se esta posando
PosarseDG:

	LDA $1510,x
	TAY
	
	LDA Posarseble,y
	STA $1510,x
	RTS


volartable: db $06,$07,$08,$09,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,$10,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A,$0A
;dirige que frame utilizar cuando esta volando
volarDG:
	
	LDA $1510,x
	TAY
	
	LDA volartable,y
	STA $1510,x
	
	RTS

tiempotiles: db $03,$20,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$00,$01,$02,$02,$02,$02,$02,$02,$02
;selecciona el frame	
seleccionar:

	LDA $1510,x
	TAY
	
	LDA tiempotiles,y
	STA $163E,x
	RTS

;====================================================
;================direccion Movimiento================
;====================================================
;pone el movimiento correspondiente
direccionMov:
	LDA $1510,x
	CMP #$11
	BCC contDMov
	STZ $B6,x
	STZ $AA,x
	JSL $01801A
	JSL $018022
	RTS
contDMov:
	LDA $C2,x
	BNE mov1
	JSR PosarseMov
	RTS
mov1:
	LDA $C2,x
	CMP #$01
	BNE mov2
	JSR perseguirMov
	RTS
mov2:
	JSR subirMov
	RTS
	
;decide el movimiento
desicionMov:
	LDA $C2,x
	BNE mov1des
	JSR cambioEstado0
	RTS
mov1des:
	LDA $C2,x
	CMP #$01
	BNE mov2des
	JSR cambioEstado1
	RTS
mov2des:
	JSR cambioEstado2
	RTS
	
retTP:
	RTS
timerPosado:
	LDA $1528,x
	BEQ retTP
	DEC $1528,x
	RTS
	
cambioEstado0:

	LDA $1528,x
	BNE Est0
	
	LDA $E4,x
	STA $00
	LDA $14E0,x
	STA $01
	
	REP #$20
	LDA $94
	STA $04
	
	LDA #$0050
	STA $08
	LDA #$0050
	STA $0A
	
	JSR detectarCercania
	BCC Est0
	
	LDA #$01
	STA $C2,x
	
	RTS
Est0withTim:
	LDA #$20
	STA $1528,x
Est0:
	STZ $C2,x
	RTS
	
cambioEstado1:
	LDA #$01
	STA $C2,x
	RTS
	
cambioEstado2:
	JSR detectarTecho
	BCC Est2
	JMP Est0withTim
Est2:
	LDA #$02
	STA $C2,x
	RTS
	
;mueve al sprite cuando se esta posando
PosarseMov:
	STZ $B6,x
	STZ $AA,x
	JSL $01801A
	JSL $018022
	RTS
	
;mueve al sprite cuando esta persiguiendo a mario
perseguirMov:

	LDA $1510,x
	CMP #$09
	BCC PosarseMov
	
	JSR invocarHumo

	LDA $D8,x
	STA $00
	LDA $14D4,x
	STA $01
	
	REP #$20
	
	LDA $96
	STA $04
	
	LDA #$0008
	STA $08
	LDA #$0008
	STA $0A
	
	JSR detectarCercania
	BCS movDer
	
	LDA $14D4,x
	CMP $97
	BEQ verLowY
	BCS irAbajo
	JMP irArriba
irAbajo:

	DEC $AA,x
	LDA $AA,x
	BPL movDer
	CMP #$E8
	BCS movDer
	LDA #$E8
	STA $AA,x
	JMP movDer
irArriba:

	INC $AA,x
	LDA $AA,x
	BMI movDer
	CMP #$18
	BCC movDer
	LDA #$18
	STA $AA,x
	JMP movDer
verLowY:
	LDA $D8,x
	CMP $96
	BCS irAbajo
	JMP irArriba
	
movDer:

	LDA $1510,x
	CMP #$09
	BCC PosarseMov

	LDA $E4,x
	STA $00
	LDA $14E0,x
	STA $01
	
	REP #$20	
	
	LDA $94
	STA $04
	
	LDA #$000A
	STA $08
	LDA #$000A
	STA $0A
	
	JSR detectarCercania
	BCC contMovDer
	STZ $B6,x
	JSL $01801A
	JSL $018022
	RTS
contMovDer:
	LDA $14E0,x
	CMP $95
	BEQ verLowX
	BCS irIzq
	BCC irDer
	RTS
irIzq:
	LDA #$E8
	STA $B6,x
	JSL $01801A
	JSL $018022
	RTS
irDer:
	LDA #$18
	STA $B6,x
	JSL $01801A
	JSL $018022
	RTS
verLowX:
	LDA $E4,x
	CMP $94
	BCC irDer
	JMP irIzq
	
;mueve al sprite cuando esta subiendo para buscar pared
subirMov:	
	JSR invocarHumo
	STZ $B6,x
	LDA #$E8
	STA $AA,x
	JSL $01802A
	LDA #$E8
	STA $AA,x
	JSL $01801A
	RTS

;====================================================
;================colision============================
;====================================================

;revisa si esta tocando el techo
detectarTecho:
	LDA $1588,x
	AND #$08
	BEQ sinTec
	STZ $1588,x
	SEC 
	RTS
sinTec:
	STZ $1588,x
	CLC
	RTS
;detecta la colision con mario	
colisionMario:

	LDA $1497
	BNE .ret
	
	LDA $1510,x
	CMP #$11
	BCS .ret

	JSR spriteFirst

	JSR MarioSecond
	
	LDA #$000A
	STA $08
	LDY $19
	BNE .big
	LDA #$0006
	BRA .small
.big
	LDA #$000C
.small
	STA $0A
	LDA #$000A
	STA $0C
	LDY $187A
	BNE .yosho1
	LDA #$001A
	STA $0E
	BRA .startFirstHitbox
.yosho1
	LDA #$0024
	STA $0E	
.startFirstHitbox
	JSR colision
	BCC .secondHitBox
.dan
	JSR daniarMario
	RTS
.secondHitBox
	REP #$20
	LDY $187A
	BNE .yosho2
	LDA #$001E
	STA $0E
	BRA .startSecontHitbox
.yosho2
	LDA #$002A
	STA $0E
.startSecontHitbox
	JSR colision
	BCC .ret
	LDA $7FAB10,x
	AND #$04
	BNE .dan
	LDY $187A
	BNE .spin 
	LDA $140D
	BEQ .dan
.spin 
	JSR spinJump	
.ret
	RTS
	
spinJump:
	JSL $01AB99
	JSL $01AA33
	LDA #$02
	STA $1DF9
	RTS
	
daniarMario:
	LDA #$02
	STA $C2,x
	STZ $B6,x
	LDA #$D0
	STA $AA,x
	JSL $01801A
	JSL $018022	
	
	LDY $187A
	BNE .loseYoshi
	JSL $00F5B7
	RTS
.loseYoshi
	JSR LOSEYOSHI
	RTS
	
vel: db $20,$E0
LOSEYOSHI:	
	LDA $187A
	BEQ NOYOSHI
	PHX
	LDX $18E2
	LDA #$10
	STA $163D,x
	LDA #$03
	STA $1DFA
	LDA #$13
	STA $1DFC
	LDA #$02
	STA $C1,x
	STZ $187A
	STZ $0DC1
	LDA #$C0
	STA $7D
	STZ $7B
	LDY $157B,x
	PHX
	TYX
	LDA vel,x
	PLX
	STA $B5,x
	STZ $1593,x
	STZ $151B,x
	STZ $18AE
	LDA #$30
	STA $1497
	PLX
NOYOSHI:
	RTS
	
;revisa la colision con todas las balas posibles
retDB:
	RTS
detectarBala:
	LDA $1510,x
	CMP #$11
	BCS .ret

	LDY #$09

.loop
	JSR colisionExt
	DEY
	CPY #$08
	BPL .loop
.ret
	RTS
	
;rutina de colision con extended sprites
colisionExt:

	LDA $170B,y
	CMP #$05
	BNE .ret

	JSR spriteFirst

	JSR extendedSecondY
	
	REP #$20
	LDA #$000A
	STA $08
	LDA #$000C
	STA $0A
	LDA #$000A
	STA $0C
	LDA #$000C
	STA $0E
	
	JSR colision
	BCC .ret
	JSR matar
.ret
	RTS
	
;pone al sprite en modalidad de muerte
matar:
	LDA #$00
	STA $170B,y
	LDA #$09
	STA $1DFC
	LDA #$11
	STA $1510,x
	JSR seleccionar
	RTS

detectarCercania:

	LDA $00
	CLC
	ADC $08
	CMP $04
	BCC .ret
	
	LDA $04
	CLC
	ADC $0A
	CMP $00
	BCC .ret
	
	SEP #$20	
	SEC
	RTS
	
.ret
	SEP #$20
	CLC
	RTS
	
	
spriteFirst:

	LDA $E4,x
	STA $00 ;set the positions of the sprite indexed by x
	LDA $14E0,x
	STA $01
	LDA $D8,x
	STA $02
	LDA $14D4,x
	STA $03
	RTS
	
MarioSecond:
	REP #$20
	LDA $94 ;set the mario positions
	STA $04
	LDA $96
	STA $06
	RTS

extendedSecondY:
	LDA $171F,y ;set the extended sprite indexed by y
	STA $04
	LDA $1733,y
	STA $05
	LDA $1715,y
	STA $06
	LDA $1729,y
	STA $07
	RTS
	
colision:
	
	LDA $00
	CLC
	ADC $08
	CMP $04
	BCC .ret 
	
	LDA $02
	CLC
	ADC $0A
	CMP $06
	BCC .ret
	
	LDA $04
	CLC
	ADC $0C
	CMP $00
	BCC .ret
	
	LDA $06
	CLC
	ADC $0E
	CMP $02
	BCC .ret
	
	SEP #$20	
	SEC
	RTS
	
.ret
	SEP #$20
	CLC
	RTS	
	
;====================================================
;================invocaciones========================
;====================================================

invocarHumo:
	LDA $7FAB28,x
	BNE .cont
	RTS
.cont
	LDA $1540,x
	CMP #$0A
	BCC	contNVHUMO
	LDA #$0A
	STA $1540,x
contNVHUMO:
	LDA $1540,x
	BNE retInvHUmo
	LDA #$0A
	STA $1540,x
	JSR InvHumo
	RTS
retInvHUmo:
	RTS
	
InvHumo:
	LDY #$19
InvHLoop1:
	
	LDA $1892,y
	BNE .next
	
	LDA !cluster
	STA $1892,y
	
	LDA #$00
	STA $0F72,y
	
	LDA #$04
	STA $1E66,y
	
	LDA $E4,x
	STA $1E16,y
	
	LDA $14E0,x
	STA $1E3E,y
	
	LDA $14D4,x
	STA $1E2A,y
	
	LDA $D8,x
	STA $1E02,y
	BRA .quit
	
.next	
	DEY
	CPY #$04
	BCC RetInvH
	JMP InvHLoop1
.quit
	
	LDA #$01 ; \ Run cluster sprite routine.
	STA $18B8
RTS
RetInvH:
	RTS

;====================================================
;================Graphics Routine====================
;====================================================

;Tables for Frames:
;###############  Tables for Frame1   #############
PROPERTIES_Frame1: 	db $27,$67,$27,$67 ;f7
					db $27,$27 ;f4
					db $27,$27 ;f3
					db $27,$27 ;f2
					db $27,$27 ;f1
					db $27,$27 ;f1
					db $27,$27 ;f2
					db $27,$27 ;f3
					db $27,$27 ;f4
					db $27,$67,$27,$67 ;f7
					db $27,$67,$27,$67,$27,$27 ;f6
					db $27,$67,$27,$67 ;f7
					db $27,$67,$27,$67 ;f8
					db $27,$67,$27,$67 ;f9
					db $27,$67,$27,$67 ;f8
					db $27,$67,$27,$67 ;f7
					db $27,$67,$27,$67,$27,$27 ;f6
					db $2D,$6D,$AD,$ED ;ex1
					db $2D,$6D,$AD,$ED ;ex2
					db $2D,$6D,$AD,$ED ;ex1
					db $2D,$6D,$2D,$6D ;ex3
					db $2D,$6D,$2D,$6D ;ex4
					db $2D,$6D,$2D,$6D ;ex5
					db $2D,$6D,$2D,$6D ;ex6
					db $2D,$6D,$2D,$6D ;ex7
					db $2D,$6D ;ex8
					
TILEMAP_Frame1: 	db $8A,$8A,$AA,$AA ;f5
					db $88,$A6 ;f4
					db $A6,$EE ;f3
					db $A6,$86 ;f2
					db $A6,$EC ;f1					
					db $A6,$EC ;f1
					db $A6,$86 ;f2
					db $A6,$EE ;f3
					db $88,$A6 ;f4
					db $8A,$8A,$AA,$AA ;f5
					db $80,$80,$A0,$A0,$82,$A2 ;f6
					db $84,$84,$A4,$A4 ;f7
					db $8C,$8C,$AC,$AC ;f8
					db $8E,$8E,$AE,$AE ;f9
					db $8C,$8C,$AC,$AC ;f8
					db $84,$84,$A4,$A4 ;f7
					db $80,$80,$A0,$A0,$82,$A2 ;f6
					db $B8,$B8,$B8,$B8 ;ex1
					db $C2,$C2,$C2,$C2 ;ex2
					db $B8,$B8,$B8,$B8 ;ex1
					db $C4,$C4,$E0,$E0 ;ex3
					db $C6,$C6,$E2,$E2 ;ex4
					db $C8,$C8,$E4,$E4 ;ex5
					db $CA,$CA,$E6,$E6 ;ex6
					db $CC,$CC,$E8,$E8 ;ex7
					db $CE,$CE ;ex8
					
XDISP_Frame1: 		db $F8,$08,$F8,$08 ;f5
					db $00,$00 ;f4
					db $00,$00 ;f3
					db $00,$00 ;f2
					db $00,$00 ;f1
					db $00,$00 ;f1
					db $00,$00 ;f2
					db $00,$00 ;f3
					db $00,$00 ;f4
					db $F8,$08,$F8,$08 ;f5
					db $F0,$0F,$F0,$0F,$00,$00 ;f6
					db $F8,$07,$F8,$07 ;f7
					db $F8,$07,$F8,$07 ;f8
					db $F8,$07,$F8,$07 ;f9
					db $F8,$07,$F8,$07 ;f8
					db $F8,$07,$F8,$07 ;f7
					db $F0,$0F,$F0,$0F,$00,$00 ;f6
					db $00,$08,$00,$08 ;ex1
					db $F8,$08,$F8,$08 ;ex2
					db $00,$08,$00,$08 ;ex1
					db $F8,$08,$F8,$08 ;ex3
					db $F8,$08,$F8,$08 ;ex4
					db $F8,$08,$F8,$08 ;ex5
					db $F8,$08,$F8,$08 ;ex6
					db $F8,$08,$F8,$08 ;ex7
					db $F8,$08 ;ex8
					
					
YDISP_Frame1: 		db $00,$00,$10,$10 ;f5
					db $00,$10 ;f4
					db $10,$00 ;f3
					db $10,$00 ;f2
					db $10,$00 ;f1					
					db $10,$00 ;f1
					db $10,$00 ;f2
					db $10,$00 ;f3
					db $00,$10 ;f4
					db $00,$00,$10,$10 ;f5
					db $00,$00,$10,$10,$00,$10 ;f6
					db $00,$00,$10,$10 ;f7
					db $00,$00,$10,$10 ;f8
					db $00,$00,$10,$10 ;f9
					db $00,$00,$10,$10 ;f8
					db $00,$00,$10,$10 ;f7
					db $00,$00,$10,$10,$00,$10 ;f6
					db $00,$00,$08,$08 ;ex1
					db $F8,$F8,$08,$08 ;ex2
					db $00,$00,$08,$08 ;ex1
					db $F8,$F8,$08,$08 ;ex3
					db $F8,$F8,$08,$08 ;ex4
					db $F8,$F8,$08,$08 ;ex5
					db $F8,$F8,$08,$08 ;ex6
					db $F8,$F8,$08,$08 ;ex7
					db $F8,$F8 ;ex8

iniPos: db $03,$05,$07,$09,$0B,$0D,$0F,$11,$13,$17,$1D,$21,$25,$29,$2D,$31,$37,$3B,$3F,$43,$47,$4B,$4F,$53,$57,$59
finPos: db $00,$04,$06,$08,$0A,$0C,$0E,$10,$12,$14,$18,$1E,$22,$26,$2A,$2E,$32,$38,$3C,$40,$44,$48,$4C,$50,$54,$58
tilesF: db $03,$01,$01,$01,$01,$01,$01,$01,$01,$03,$05,$03,$03,$03,$03,$03,$05,$03,$03,$03,$03,$03,$03,$03,$03,$01
Tamani: db $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$00,$02,$00,$02,$02,$02,$02,$02,$02

Graphics:

JSR GET_DRAW_INFO

LDA $06
BEQ .cont
RTS
.cont

PHX

LDA $1510,x
TAX

LDA finPos,x
STA $0A

LDA tilesF,x
STA $0B

LDA Tamani,x
STA $0C

LDA iniPos,x
TAX

.loop
LDA $00
CLC
ADC XDISP_Frame1,x
STA $0300,y

LDA $01
CLC
ADC YDISP_Frame1,x
STA $0301,y

LDA TILEMAP_Frame1,x
STA $0302,y

LDA PROPERTIES_Frame1,x
ORA $64
STA $0303,y

INY
INY
INY
INY

DEX
BMI .quit
CPX $0A
BCS .loop
.quit
PLX

LDY $0C
LDA $0B
JSL $01B7B3
RTS


;###################Subroutines#####################3

SPR_T1:              db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:  
    
	STZ $06
	STZ $186C,x             ; reset sprite offscreen flag, vertical
	STZ $15A0,x             ; reset sprite offscreen flag, horizontal
	LDA $E4,x               ; \
	CMP $1A                 ;  | set horizontal offscreen if necessary
	LDA $14E0,x             ;  |
	SBC $1B                 ;  |
	BEQ ON_SCREEN_X         ;  |
	INC $15A0,x             ; /

ON_SCREEN_X:  
       
	LDA $14E0,x             ; \
	XBA                     ;  |
	LDA $E4,x               ;  |
	REP #$20                ;  |
	SEC                     ;  |
	SBC $1A                 ;  | mark sprite invalid if far enough off screen
	CLC                     ;  |
	ADC #$0040            ;  |
	CMP #$0180            ;  |
	SEP #$20                ;  |
	ROL A                   ;  |
	AND #$01                ;  |
	STA $15C4,x             ; / 
	BNE INVALID             ; 
                    
	LDY #$00                ; \ set up loop:
	LDA $1662,x             ;  | 
	AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
	BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
	INY                     ; / 

ON_SCREEN_LOOP:

	LDA $D8,x               ; \ 
	CLC                     ;  | set vertical offscreen if necessary
	ADC SPR_T1,y            ;  |
	PHP                     ;  |
	CMP $1C                 ;  | (vert screen boundry)
	ROL $00                 ;  |
	PLP                     ;  |
	LDA $14D4,x             ;  | 
	ADC #$00                ;  |
	LSR $00                 ;  |
	SBC $1D                 ;  |
	BEQ ON_SCREEN_Y         ;  |
	LDA $186C,x             ;  | (vert offscreen)
	ORA SPR_T2,y            ;  |
	STA $186C,x             ;  |

ON_SCREEN_Y:

	DEY                     ;  |
	BPL ON_SCREEN_LOOP      ; /

	LDY $15EA,x             ; get offset to sprite OAM
	LDA $E4,x               ; \ 
	SEC                     ;  | 
	SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
	STA $00                 ; / 
	LDA $D8,x               ; \ 
	SEC                     ;  | 
	SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
	STA $01                 ; / 
	RTS                     ; return

INVALID:

	LDA #$01
	STA $06                    ;  |    ...(not just this subroutine)
	RTS                     ; /	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B85D - off screen processing code - shared
; sprites enter at different points
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T12:             db $40,$B0
SPR_T13:             db $01,$FF
SPR_T14:             db $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            db $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15:             db $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					db $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1:   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:   LDA #$0C                ;  |
                    BRA STORE_03            ;  | OMG YOU FOUND THIS HIDDEN z0mg place!111 you win a cookie!
SUB_OFF_SCREEN_X7:   LDA #$0E                ;  |
STORE_03:			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0:   STZ $03					; /

START_SUB:           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:         STZ $14C8,x             ; erase sprite
RETURN_35:           RTS                     ; return

VERTICAL_LEVEL:      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / 